import argparse
from paffi import load_topology, save_topology, connect_naive, connect_ampl

# FIXME: should add a .json or a .ini file with the configuration
parser = argparse.ArgumentParser()
parser.add_argument("-i", "--input", help="Scenario file. Default: topology.json")
parser.add_argument("-o", "--output", help="Scenario output file. Default: conn_topology.json")
parser.add_argument("-a", "--ampl",
                    help="AMPL output for topology mapping. Default = None (use nearest fog for mapping)")
args = parser.parse_args()

# load data
infile = args.input if args.input else "topology.json"
outfile = args.output if args.output else "conn_topology.json"
topology = load_topology(infile)

if args.ampl:
    connect_ampl(topology, args.ampl)
else:
    connect_naive(topology)

save_topology(topology, outfile)
