from paffi.topology import get_delays, set_connection_type, get_delay_source, get_delay_destination, get_delay, \
    set_connection


def step_connect_naive(topology, delaytype, conntype):
    conn = {}
    for i in get_delays(topology, delaytype):
        src = get_delay_source(topology, delaytype=delaytype, lbl=i)
        dst = get_delay_destination(topology, delaytype=delaytype, lbl=i)
        d = get_delay(topology, delaytype=delaytype, lbl=i)
        connd = conn[src]['delay'] if src in conn else None
        if (connd is None) or (d < connd):
            conn[src] = {'delay': d, 'dst': dst}
    for i in conn:
        set_connection(topology, conntype=conntype, src=i, dst=conn[i]['dst'])


def connect_naive(topology):
    set_connection_type(topology, 'naive')
    step_connect_naive(topology, 'delay_sf', 'conn_sf')
    step_connect_naive(topology, 'delay_fc', 'conn_fc')
